import type { ExtractionLog, LoggerContext, TransmissionLog } from '../types/LoggerTypes';
import type { LogBoundaryProps } from '../types/LogBoundaryTypes';
type LoggerProps = Partial<LoggerContext> & Omit<LoggerContext, 'timestamp' | 'content' | 'deviceInfo' | 'userID'>;
export declare const useRookLogger: () => {
    initLogger: (props: LoggerProps) => void;
    sendExtractionLog: (content: ExtractionLog) => void;
    sendTransmissionLog: (content: TransmissionLog) => void;
    logBoundary: <T>(props: LogBoundaryProps<T>) => Promise<T>;
};
export {};
//# sourceMappingURL=useRookLogger.d.ts.map